﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Infragistics.Controls.Grids;

namespace XamGrid_EditorDisplayBehavior_Bug
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();

            this.Loaded += new RoutedEventHandler(MainPage_Loaded);
        }

        void MainPage_Loaded(object sender, RoutedEventArgs e)
        {
            var dataSource = new List<DataItem>();

            for (int i = 0; i < 20; i++)
                dataSource.Add(new DataItem(i));

            xwGrid.ItemsSource = dataSource;

            ComboBoxColumn comboBoxColumn = new ComboBoxColumn();
            comboBoxColumn.ItemsSource = dataSource.Select(d => new IntegerWrapper(d.Integer));
            comboBoxColumn.HeaderText = "IntegerColumn";
            comboBoxColumn.Key = "Integer";
            comboBoxColumn.DisplayMemberPath = "StringInt";
            comboBoxColumn.SelectedValuePath = "Int";

            xwGrid.Columns.Add(comboBoxColumn);
        }
    }

    public class DataItem
    {
        public DataItem()
        {
            this.Integer = 0;
            this.BoolNull = null;
            this.DateTime = DateTime.Now;
        }
        public DataItem(int id) 
            :this()
        {
            this.Integer = id;
        }

        public int Integer { get; set; }
        public bool? BoolNull { get; set; }
        public DateTime DateTime { get; set; }
    }

    public class IntegerWrapper
    {
        public IntegerWrapper(int id)
        {
            this.Int = id;
        }

        public int Int { get; set; }
        public string StringInt 
        {
            get
            {
                return "Str " + this.Int.ToString();
            }
        }
    }
}
